
#define SegA	1
#define SegB	2
#define SegC	4
#define SegD	8
#define SegE	0x10
#define SegF	0x20
#define SegG	0x40
#define SegH	0x80

#define digit_0	~(SegA | SegB | SegC | SegD | SegE | SegF)
#define digit_1	~(SegB | SegC)
#define digit_2	~(SegA | SegB | SegD | SegE | SegG)
#define digit_3	~(SegA | SegB | SegC | SegD | SegG)
#define digit_4	~(SegB | SegC | SegF | SegG)
#define digit_5	~(SegA | SegC | SegD | SegF | SegG)

#define digit_6	~(SegA | SegC | SegD | SegE | SegF | SegG)
#define digit_7	~(SegA | SegB | SegC)
#define digit_8	~(SegA | SegB | SegC | SegD | SegE | SegF | SegG)
#define digit_9	~(SegA | SegB | SegC | SegD | SegF | SegG)

#define digit_A	~(SegA | SegB | SegC | SegE | SegF | SegG)
#define digit_B	~(SegC | SegD | SegE | SegF | SegG)
#define digit_C	~(SegA | SegD | SegE | SegF)
#define digit_D	~(SegB | SegC | SegD | SegE | SegG)
#define digit_E	~(SegA | SegD | SegE | SegF | SegG)
#define digit_F	~(SegA | SegE | SegF | SegG)

//----------------------------------------------------------------
void LED4D4Clock (void)
{
	bit_on(LED4S);
_delay_loop_2(10);	
	bit_off(LED4S);
}
//----------------------------------------------------------------
void LEDbyte (u08 b)  //    
{
u08 j;
 for (j=0x80;j>0;j>>=1) 
 {
  if ((j & b) !=0) bit_on(LED4D);
  else bit_off(LED4D);
  	bit_on(LED4S);
_delay_loop_2(20);	
	bit_off(LED4S);
 }
}
//----------------------------------------------------------------
void LED4byte (u08 b)  //  4   
{
u08 i;
 for (i=0;i<4;i++) LEDbyte(b);
  	bit_on(LED4W);
_delay_loop_2(10);	 
	bit_off(LED4W);
}
//----------------------------------------------------------------
void DisplayLED(void) //    0  F
{
LED4byte (0xFF);
 BigDelay(100);
LED4byte (digit_0);
 BigDelay(100);
LED4byte (digit_1);
 BigDelay(100);
LED4byte (digit_2);
 BigDelay(100);
LED4byte (digit_3);
 BigDelay(100);
LED4byte (digit_4);
 BigDelay(100);
LED4byte (digit_5);
 BigDelay(100); 
LED4byte (digit_6);
 BigDelay(100);
LED4byte (digit_7);
 BigDelay(100);
LED4byte (digit_8);
 BigDelay(100); 
LED4byte (digit_9);
 BigDelay(100); 

LED4byte (digit_A);
 BigDelay(100); 
 
LED4byte (digit_B);
 BigDelay(100); 

LED4byte (digit_C);
 BigDelay(100); 

LED4byte (digit_D);
 BigDelay(100); 

LED4byte (digit_E);
 BigDelay(100); 

LED4byte (digit_F);
 BigDelay(100); 
}

